/*
  Copyright (C) MOXA Inc. All rights reserved.
  This software is distributed under the terms of the
  MOXA License.  See the file COPYING-MOXA for details.
*/
// udpclientDlg.h : header file
//

#if !defined(AFX_UDPCLIENTDLG_H__8FAED746_94B5_11D6_A76B_0050BAE51080__INCLUDED_)
#define AFX_UDPCLIENTDLG_H__8FAED746_94B5_11D6_A76B_0050BAE51080__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct _PARAVAR{
	char	butflag;
	DWORD	count;
	DWORD	dataidx;
	CString	data;
	DWORD	sendcnt;
	DWORD	recvcnt;
	DWORD	senderr;
	DWORD	recverr;
	DWORD	flag;
	CEdit	*predit;
}PARAVAR, *PPARAVAR;

/////////////////////////////////////////////////////////////////////////////
// CUdpclientDlg dialog

class CUdpclientDlg : public CDialog
{
// Construction
public:
	CWinThread *m_precvthread;
	CWinThread *m_psendthread;
	CString m_defultdata;
	DWORD m_ipvar;
	PARAVAR m_paravar;
	BOOL m_connectflag;
	struct sockaddr_in m_sockinfo;
	struct sockaddr_in m_sockinfocli;
	SOCKET m_sock;
	void UpdateButton();
	CUdpclientDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CUdpclientDlg)
	enum { IDD = IDD_UDPCLIENT_DIALOG };
	CIPAddressCtrl	m_serip;
	CString	m_count;
	CString	m_port;
	CString	m_senddata;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CUdpclientDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CUdpclientDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnSendbut();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_UDPCLIENTDLG_H__8FAED746_94B5_11D6_A76B_0050BAE51080__INCLUDED_)
