/*
  Copyright (C) MOXA Inc. All rights reserved.
  This software is distributed under the terms of the
  MOXA License.  See the file COPYING-MOXA for details.
*/
#ifndef USBCF_H
#define USBCF_H
/*
 * This is a example program to show how to detect the USB/CF storage plugin or
 * unplug. And check it mounts OK or fail.
 *
 * History:
 * Date		Author			Comment
 * 03-08-2006	Victor Yu.		Create it.
 */

#define STORAGE_PLUGIN		1	// it means the storage plugin OK.
					// but mount fail !
#define STORAGE_UNPLUG		2	// it means the storage unplug
#define STORAGE_MOUNT		3	// it means the storage plugin OK.
					// and mount OK.
int	CFFree();
// input: int num	- want to check USB storage number
// 			  you must be 0 or 1
int 	USBFree( int num);
int	CheckCF();
// input: int num	- want to check USB storage number
// 			  you must be 0 or 1
int	CheckUSB( int num);
#endif
